#include "dvector.hpp"
#include <math.h>
#include <stdlib.h>


#define error(s,t) error_func(__LINE__,__FILE__,s,t)


int error_func(unsigned l,char *f,char *s1,char *s2)
{
fprintf(stderr,"Error on line %d of source file %s:\n %s%s\n\n",l,f,s1,s2);
exit(1);
return 0;
}

main(int argc, char *argv[])
{
int SIZE, seed;
if (argc<2 || (SIZE=atoi(argv[1]))<2)
  {
  printf("Invert a random matrix.  Usage: invtst size [random_number_seed]\n");
  return 1;
  }
if (argc>2) seed=atoi(argv[2]);
dv2d A(SIZE,SIZE);
srand(seed);
int i,j;
for (i=0;i<SIZE;++i)
  for (j=0;j<SIZE;++j)
    A[i][j]=rand()%100;
printf("\nOriginal matrix:\n");
A.print();
dv2d Inv=A.inv();
printf("\nInverse:\n");
Inv.print();
dv2d test=A*Inv;
printf("\nProduct of original with inverse:\n");
test.print();
return 0;
}
